; 
; Modified 2005-01-05 U.Neudecker
    .486                        ; force 32 bit code
    .model flat, stdcall        ; memory model & calling convention
    option casemap :none        ; case sensitive
; 
; 
.code
align 16
  ; --------------------------------------
  ; scan string for match
  ; Returning 0   : Match
  ;           1   ; str1 > str2
  ;          -1   ; str1 < str2
  ; --------------------------------------

;#######################################################################
;  DWORD-wise 
;#######################################################################
StrComp proc uses ecx edx edi, str1:DWORD, str2:DWORD, strlen:dword
    mov ecx, str1
    mov edx, str2
    mov edi, strlen
        
    mov al, [ecx]                 ; pre check
    cmp al, byte ptr [edx]
    jne no_match2

    shr edi, 2
    .while edi > 0
        mov eax, [ecx]
        cmp eax, [edx]
        jne no_match1
        add edx, 4
        add ecx, 4        
        dec edi
    .endw    
    mov edi, strlen
    and edi, 3
    .while edi > 0
        mov al, [ecx]
        cmp al, byte ptr [edx]
        jne no_match2
        add edx, 1
        add ecx, 1        
        dec edi
    .endw
    
    xor eax, eax
    ret

  no_match2:
      .if al < byte ptr[edx]
        mov eax, dword ptr[-1]
      .else
      mov eax, 1
    .endif
    ret

  no_match1:
      mov ecx, [edx]
      bswap eax             ; to get the right byte-order !
      bswap ecx
      .if eax < ecx
        mov eax, dword ptr[-1]
      .else
        mov eax, 1
      .endif
      ret
  
StrComp endp
end
